<?php
/**
 * Created by PhpStorm.
 * User: 37708
 * Date: 2018/9/6
 * Time: 21:41
 */

require('./SCS.php');
/*这里换成你的AccessKey和SecretKey*/
$accessKey = 'AccessKey';
$secretKey = 'SecretKey';
/*这里换成你自己的bucket名称*/
$bucket = 'sinaappengine';
$scs_instance = new SCS($accessKey, $secretKey);
$scs_instance->setExceptions(true);
/*本地的文件*/
$file = '2M.file';
/*写到云存储中的路径*/
$object = 'example_folder/'.$file;
try {
    //初始化上传
    $info = $scs_instance->initiateMultipartUpload($bucket, $object, SCS::ACL_PUBLIC_READ);
    $uploadId = $info['upload_id'];
    $fp = fopen($file, 'rb');
    $i = 1;
    $part_info = array();

    while (!feof($fp)) {
        /*上传分片，一个分片512KB*/
        $res = $scs_instance->putObject($scs_instance->inputResourceMultipart($fp, 1024 * 512, $uploadId, $i), $bucket, $object);
        if (isset($res['hash'])) {
            echo 'Part: ' . $i . " OK! \n";
            $part_info[] = array(
                'PartNumber' => $i,
                'ETag' => $res['hash'],
            );
        }
        $i++;
    }

    //列分片
    $parts = $scs_instance->listParts($bucket, $object, $uploadId);

    if (count($parts) > 0 && count($parts) == count($part_info)) {
        foreach ($parts as $part_number => $part) {
            if ($part['etag'] != $part_info[$part_number - 1]['ETag']) {
                exit('part not match');
                break;
            }
        }
        //合并分片
        echo "start complete action\n";
        $scs_instance->completeMultipartUpload($bucket, $object, $uploadId, $part_info);
        echo "upload success\n";
        fclose($fp);
    }
} catch (SCSException $e) {
    echo $e->getMessage();
}